package ru.dbotthepony.mc.otm.menu.slot;

import net.minecraft.world.Container;
import net.minecraft.world.inventory.Slot;
import net.minecraft.world.item.ItemStack;
import net.minecraftforge.common.util.LazyOptional;
import net.minecraftforge.energy.CapabilityEnergy;
import net.minecraftforge.energy.IEnergyStorage;
import ru.dbotthepony.mc.otm.capability.IMatteryEnergyStorage;
import ru.dbotthepony.mc.otm.capability.MatteryCapability;

import java.util.Optional;

public class BatterySlot extends Slot {
	public BatterySlot(Container container, int index, int x, int y) {
		super(container, index, x, y);
	}

	@Override
	public boolean mayPlace(ItemStack stack) {
		Optional<IMatteryEnergyStorage> storage = stack.getCapability(MatteryCapability.ENERGY).resolve();

		if (storage.isPresent()) {
			return storage.get().canExtractOuter();
		}

		LazyOptional<IEnergyStorage> capability = stack.getCapability(CapabilityEnergy.ENERGY);
		return capability.resolve().isPresent() && capability.resolve().get().canExtract();
	}
}
