package ru.dbotthepony.mc.otm.screen;

import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.network.chat.Component;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.entity.player.Inventory;
import ru.dbotthepony.mc.otm.OverdriveThatMatters;
import ru.dbotthepony.mc.otm.menu.AndroidStationMenu;
import ru.dbotthepony.mc.otm.menu.BatteryBankMenu;
import ru.dbotthepony.mc.otm.menu.MatteryMenu;

public class BatteryBankScreen extends MatteryScreen<BatteryBankMenu> {
	private static final ResourceLocation CONTAINER_BACKGROUND = new ResourceLocation(OverdriveThatMatters.MOD_ID, "textures/gui/battery_bank.png");

	@Override
	protected ResourceLocation CONTAINER_BACKGROUND() {
		return CONTAINER_BACKGROUND;
	}

	public BatteryBankScreen(BatteryBankMenu p_97741_, Inventory p_97742_, Component p_97743_) {
		super(p_97741_, p_97742_, p_97743_);
	}

	@Override
	protected void renderTooltip(PoseStack p_97791_, int mouseX, int mouseY) {
		super.renderTooltip(p_97791_, mouseX, mouseY);

		if (this.hoveredSlot == null && menu.getCarried().isEmpty() && hovering_power_gauge) {
			this.renderComponentToolTip(p_97791_, getFormattedPowerLevel(() -> menu.energy.getDecimal(), () -> menu.max_energy.getDecimal()), mouseX, mouseY, font);
		}
	}

	@Override
	protected void renderBg(PoseStack pose, float p_97788_, int mouseX, int mouseY) {
		super.renderBg(pose, p_97788_, mouseX, mouseY);
		renderPowerGauge(pose, 15, 24, mouseX, mouseY, () -> menu.energy.getDecimal(), () -> menu.max_energy.getDecimal());
	}
}
