package ru.dbotthepony.mc.otm.screen;

import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.FormattedText;
import net.minecraft.world.entity.player.Inventory;
import ru.dbotthepony.mc.otm.menu.PoweredMatteryMenu;

import java.util.List;

public class PoweredMachineScreen<T extends PoweredMatteryMenu> extends MatteryScreen<T> {
	protected boolean auto_draw_gauge = true;
	protected int power_gauge_x = 13;
	protected int power_gauge_y = 15;

	public PoweredMachineScreen(T p_97741_, Inventory p_97742_, Component p_97743_) {
		super(p_97741_, p_97742_, p_97743_);
	}

	@Override
	protected void renderTooltip(PoseStack p_97791_, int mouseX, int mouseY) {
		super.renderTooltip(p_97791_, mouseX, mouseY);

		if (this.hoveredSlot == null && menu.getCarried().isEmpty() && hovering_power_gauge) {
			this.renderComponentToolTip(p_97791_, getFormattedPowerLevel(), mouseX, mouseY, font);
		}
	}

	protected List<FormattedText> getFormattedPowerLevel() {
		return getFormattedPowerLevel(() -> menu.energy.getDecimal(), () -> menu.max_energy.getDecimal());
	}

	protected void renderPowerGauge(PoseStack pose, int x, int y, int mouseX, int mouseY) {
		renderPowerGauge(pose, x, y, mouseX, mouseY, () -> menu.energy.getDecimal(), () -> menu.max_energy.getDecimal());
	}

	@Override
	protected void renderBg(PoseStack pose, float p_97788_, int mouseX, int mouseY) {
		super.renderBg(pose, p_97788_, mouseX, mouseY);

		if (auto_draw_gauge)
			renderPowerGauge(pose, power_gauge_x, power_gauge_y, mouseX, mouseY);
	}
}
